
exception Unimplemented

type exp = Var of string 
         | Lam of string * exp
	 | Apply of exp * exp
	 | Int of int
	 | Plus of exp * exp
	 | A of exp
	 | B of exp
	 | Match of exp * string * exp * string * exp
	 | Pair of exp * exp
	 | First of exp
	 | Second of exp

(* a helper function that was useful in the Match case of translate 
   and translate2 *)
let makeLet s e1 e2 = Prob23.Apply(Prob23.Lam(s,e2,None),e1)

(******** Problem 4: complete this function ********)
let rec translate e = 
  match e with
    Int i -> Prob23.Int i
  | _ -> raise Unimplemented

(******** Problem 5: complete this function ********)
let rec translate2_cps e k = 
  match e with
    Int i -> k (Prob23.Int i)
  | _ -> raise Unimplemented

let translate2 e = translate2_cps e (fun x -> x)

(********** examples and testing ***********)

(* no need to change anything here; we have provided 1 very simply test *)

let ex = Apply(Lam("x",
		    Match(Var "x",
			  "y", Plus(Int 3, Var "y"),
			  "z", Var "z")),
		A(Int 4))

let ans1 = Prob23.interp1 (translate ex)
let ans2 = Prob23.interp1 (translate2 ex)

let runtests () = 
  let p i = 
    print_string (match i with Prob23.Int i -> string_of_int i | _ -> "WRONG");
    print_newline () in
  List.iter p [ans1; ans2]
